## org.apache.tools.ant.taskdefs
Class UpToDate

    java.lang.Object
      org.apache.tools.ant.ProjectComponent
          org.apache.tools.ant.Task
              org.apache.tools.ant.taskdefs.UpToDate

All Implemented Interfaces:
  Condition

public class UpToDate
extends Task
implements Condition

Sets the given property if the specified target has a timestamp greater than all of the source files.

Since:
  Ant 1.2
Author:
  William Ferguson williamf@mincom.com, Hiroaki Nakamura hnakamur@mc.neweb.ne.jp, Stefan Bodewig

Field Summary
`protected Mapper` `mapperElement`

Fields inherited from class org.apache.tools.ant.Task
`description, location, target, taskName, taskType, wrapper`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`project`

Constructor Summary
`UpToDate()`

Method Summary
`void` `addSrcfiles(FileSet fs)` Nested <srcfiles> element.
`Mapper` `createMapper()` Defines the FileNameMapper to use (nested mapper element).
`boolean` `eval()` Evaluate (all) target and source file(s) to see if the target(s) is/are up-to-date.
`void` `execute()` Sets property to true if target file(s) have a more recent timestamp than (each of) the corresponding source file(s).
`protected boolean` `scanDir(java.io.File srcDir, java.lang.String[] files)`
`void` `setProperty(java.lang.String property)` The property to set if the target file is more up-to-date than (each of) the source file(s).
`void` `setSrcfile(java.io.File file)` The file that must be older than the target file if the property is to be set.
`void` `setTargetFile(java.io.File file)` The file which must be more up-to-date than (each of) the source file(s) if the property is to be set.
`void` `setValue(java.lang.String value)` The value to set the named property to if the target file is more up-to-date than (each of) the source file(s).

Methods inherited from class org.apache.tools.ant.Task
`getDescription, getLocation, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, handleErrorFlush, handleErrorOutput, handleFlush, handleOutput, init, isInvalid, log, log, maybeConfigure, perform, setDescription, setLocation, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`getProject, setProject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### mapperElement

    protected Mapper mapperElement

Constructor Detail

### UpToDate

    public UpToDate()

Method Detail

### setProperty

    public void setProperty(java.lang.String property)

  The property to set if the target file is more up-to-date than (each of) the source file(s).

  Parameters:
    `property` - the name of the property to set if Target is up-to-date.

### setValue

    public void setValue(java.lang.String value)

  The value to set the named property to if the target file is more up-to-date than (each of) the source file(s). Defaults to 'true'.

  Parameters:
    `value` - the value to set the property to if Target is up-to-date

### setTargetFile

    public void setTargetFile(java.io.File file)

  The file which must be more up-to-date than (each of) the source file(s) if the property is to be set.

  Parameters:
    `file` - the file we are checking against.

### setSrcfile

    public void setSrcfile(java.io.File file)

  The file that must be older than the target file if the property is to be set.

  Parameters:
    `file` - the file we are checking against the target file.

### addSrcfiles

    public void addSrcfiles(FileSet fs)

  Nested <srcfiles> element.

### createMapper

    public Mapper createMapper()
                        throws BuildException

  Defines the FileNameMapper to use (nested mapper element).

  Throws:
    `BuildException`

### eval

    public boolean eval()

  Evaluate (all) target and source file(s) to see if the target(s) is/are up-to-date.

  Specified by:
    `eval` in interface `Condition`

### execute

    public void execute()
                 throws BuildException

  Sets property to true if target file(s) have a more recent timestamp than (each of) the corresponding source file(s).

  Overrides:
    `execute` in class `Task`
  Throws:
    `BuildException` - if something goes wrong with the build

### scanDir

    protected boolean scanDir(java.io.File srcDir,
                              java.lang.String[] files)

Copyright © 2000-2003 Apache Software Foundation. All Rights Reserved.